#ifndef __H_UTILS__
#define __H_UTILS__

#include "defs.h"

/** @file
 * Utils, a collection of utility functions that are not directly relaned to
 * the game.
 *
 * For game utility functions see <tt>game_utils.h</tt>
 */

BEGIN_DECLS

/**
 * We assume that this is the maximum size that any string that is created at
 * runtime will ever be.
 */
#define _STR_MAX_LEN 2048

/**
 * Create a new string with just enough space.
 *
 * @param format A printf-format string.
 * @param ... The variables.
 *
 * @returns A C String on succses
 * @returns NULL on fail.
 */
char * string_new_printf (char * format, ...);

END_DECLS

#endif /*__H_UTILS__*/
