#include <stdio.h>
#include <assert.h>
#include "../../src/DynamicArray.h"

void test_for_each (DynamicArray * self, void * item, void * data) {
  /* We do not care for the array at all, rely. Why it can be passed to the
   * for_each is becouse it may be useful when dealing with recursive cases,
   * or something...
   */
  int * m_item = item;
  fprintf (stdout,"%d\n", *m_item);
}

int main (int argc, char ** argv) {
  
  int initial_size = 5;
  
  DynamicArray * array = dynamic_array_new (initial_size, NULL);
  
  assert (dynamic_array_size (array) == initial_size);
  assert (dynamic_array_len (array) == 0);
  
  int num_itt = 1000;
  for (int i = 0; i < num_itt; i++) {
    int * data = malloc (sizeof (int));
    *data = i;
    dynamic_array_add (array, data);
    
    int * i_n = dynamic_array_get (array, i);
    assert ( *i_n == i);
  }
  
  assert (dynamic_array_size (array) != initial_size);
  assert (dynamic_array_len (array) == num_itt);
  
  dynamic_array_for_each (array, (ForEachFunc) test_for_each, NULL);
  
  dynamic_array_free (array);
  
  return 0;
}
